;; echo.scm - test a user script.
;; Copyright (C) 2011 Sergey Poznyakoff
;; License GPLv3+: GNU GPL version 3 or later
;;  <http://gnu.org/licenses/gpl.html>
;; This is free software: you are free to change and redistribute it.
;; There is NO WARRANTY, to the extent permitted by law.

(let ((cmd (command-line)))
  (cond
   ((< (length cmd) 3)
    (error "usage: echo.scm SCRIPT FILE...")
    (exit 1))
   (else
    (let ((file-name (list-ref cmd 1)))
      (set-program-arguments (cons (car cmd) (list-tail cmd 2)))
      (load file-name)
      (cond
       (idest-readonly
	(format (current-error-port)
		"~A does not modify frames~%" file-name)
	(exit 1))
       ((catch #t
	       (lambda ()
		 (procedure? idest-main))
	       (lambda (key . args)
		 #f))
	(set! idest-readonly #t)
	(let ((main-func idest-main))
	  (set! idest-main
		(lambda (file frames)
		  (let ((result (main-func file frames)))
		    (format #t "File ~A ~A~%" file result))))))
       (else
	(format (current-error-port)
		"idest-main is not defined in ~A~%" file-name)
	(exit 1)))))))

